#include "StdAfx.h"
#include "PadListBox.h"
#include "SimpleTextShape.h"
#include "Application.h"
#include "PutPreviewDataAction.h"

namespace tipuio {

REGISTER_COMPONENT_CREATOR(_T("PadListBox"), PadListBox);
REGISTER_SCRIPTLETCONTAINER_CREATOR(_T("SelectLayoutAction"), SelectLayoutAction);

void PadListBox::OnCreate()
{
	ListUpLayout();
}
void PadListBox::ListUpLayout()
{
	Application* application = Application::get_instance();
	if (application == NULL) return;

	CAtlMap< CString, TiXmlElement* > lstNode;
	if (application->GetLayoutLoader()->GetNodeList(lstNode))
	{
		POSITION pos = lstNode.GetStartPosition();
		while (pos)
		{
			CAtlMap< CString, TiXmlElement* >::CPair* pPair = lstNode.GetNext(pos);
			PadListItem* item = new PadListItem(pPair->m_key, pPair->m_value);
			this->AddItem(item);			
		}		
	}
}

void SelectLayoutAction::OnSelect(Item* item)
{
	PadListItem* paditem = dynamic_cast<PadListItem*>(item);
	if (paditem != NULL)
	{
		TiXmlElement* node = paditem->GetNode();
		if (node)
		{
			PutPreviewDataAction* action = dynamic_cast<PutPreviewDataAction*>(TipCommandFactory::get_instance()->CreateAction(_T("PutPreviewDataAction")));
			action->SetPreviewNode(node);
			action->Execute();
		}
	}
}
void SelectLayoutAction::OnUnselect(Item* item)
{

}

};